#ifndef _EXTERNAL_H_
#define _EXTERNAL_H_

#include <vector>

using namespace std;

template<class T> class ColumnMatrix
{
	int rows, columns;
	T *_data;
public:
	ColumnMatrix(int _rows, int _columns) : rows (_rows), columns (_columns)
		{_data = new T[rows*columns];}
	ColumnMatrix(int _rows, int _columns, T t) : rows (_rows), columns (_columns)
		{_data = new T[rows*columns];for ( int i=0;i<rows*columns;++i)_data[i]=t;}
	ColumnMatrix(const ColumnMatrix<T> &m) : rows (m.rows), columns (m.columns)
		{_data = new T[rows*columns];for ( int i=0;i<rows*columns;++i)_data[i]=m._data[i];}
	~ColumnMatrix()
		{delete[] _data;}
	////T& operator[] (int row, int column) {return data [column*rows+ row];}
	T& operator() (int row, int column) {return _data [column*rows+ row];}
	T* data() {return _data;}
	int minor() {return rows;}
	int nrows() {return rows;}
	int ncols() {return columns;}
};


extern "C" {
int dgelss_ (const int& m, const int& n, const int& nrhs, 
	      double da[], const int& lda, double b[], const int& ldb,
	      double s[], const double& rcond, int& rank,
	      double work[], const int& ldwork, int& info);

void sgelss_ (const int& m, const int& n, const int& nrhs, 
	      float da[], const int& lda, float b[], const int& ldb,
	      float s[], const float& rcond, int& rank,
	      float work[], const int& ldwork, int& info);
}

ColumnMatrix<double> pseudoinverse(ColumnMatrix<double>& a, double tol=1.e-6)
{
   int m   = static_cast < int > (a.nrows());
   int n   = static_cast < int > (a.ncols());
   int nrhs = m;
   int lda = static_cast < int > (a.minor());
   //set b to be the identity matrix
  ColumnMatrix<double> b(m,m,0.0);
   for ( int i = 0; i < m; ++i)
	   b(i,i)=1.0;
   int ldb = static_cast < int > (b.minor());
int rank, info;

	//// 
 /*  double temporarywork[1];
int ldwork =-1;
   double temporarys[1];
dgelss_(m, n, nrhs, a.data(), lda, b.data(), ldb, temporarys, tol, rank, temporarywork, ldwork, info);
*/
int ldwork =5*m*max(m,n);
   double* work = new double[ldwork];
   double* s = new double[ldwork];
	int result = dgelss_(m, n, nrhs, a.data(), lda, b.data(), ldb, s, tol, rank, work, ldwork, info);

   delete [] work;
   delete [] s;
if (result!= 0) throw;//run out of memory 

   return b;
 }

#endif