#ifndef _TYPES_H_
#define _TYPES_H_

#include <vector>
#include <fstream>
using namespace std;

template<class T> class DisplacedVector
{
	int _beginindex, _endindex;
	vector<T> data;
public:
	DisplacedVector(int set_beginindex, int set_endindex) 
		: _beginindex (set_beginindex), _endindex(set_endindex), data(_endindex - _beginindex) {}
	DisplacedVector(int set_beginindex, int set_endindex, T t) 
		: _beginindex (set_beginindex), _endindex(set_endindex), data(_endindex - _beginindex, t) {}
	DisplacedVector(const DisplacedVector<T> &dv) 
		: _beginindex (dv._beginindex), _endindex(dv._endindex), data(dv.data) {}
	int beginindex() const {return _beginindex;}
	int endindex() const {return _endindex;}
	int size() const {return int(data.size());}
	//T operator[] (int n) const {return data[n-_beginindex];}
	//T &operator[] (int n) {return data[n-_beginindex];}
	T operator[] (int n) const {return data.at(n-_beginindex);}
	T &operator[] (int n) {return data.at(n-_beginindex);}
	T at(int n) const {return data.at(n-_beginindex);}
	T &at(int n) {return data.at(n-_beginindex);}
	
	//T first() const {return data.at(0);}
	//T last() const {return data.at(_endindex-1 - _beginindex);}
	bool definedat(int n) const {return n>=_beginindex && n < _endindex;}
};

template<class T> inline ostream &operator<<(ostream &o, DisplacedVector<T> v)
{
	//o << "[" << v.beginindex() << "," << v.endindex() << ")\t";
	o << "\t";
	for(int i = v.beginindex(); i < v.endindex(); ++i)
	{
		o << "[" << i << "]=" << v[i] << "\t";
	}
	return o;
}

inline int floor (double f)
{
	return int(f);
}

inline int ceiling (double f)
{
	int floor = int(f);
	if (f == double(floor)) return floor;
	return floor + 1;
}
//
#endif