#include "stdafx.h"
#include "woven.h"

//extern map<string, int> calls;

DisplacedVector<double> Halve::weight(int outframe, IScriptEnvironment *env) /*const*/
{
	return  DisplacedVector<double>(outframe*2 + parity, outframe*2 + parity + 1, 1.0);
}

ReverseHalfBlend::ReverseHalfBlend(PClip _toreverse, Blend *_blend, int _parity, IScriptEnvironment *env)
	: GenericVideoFilter(_toreverse), blend(_blend), parity(_parity),
	halve(parity), composite(*blend, halve), 
	reversed(new ReverseBlend(new SelectParity(_toreverse, parity, env), composite, env))
{
	//int originalframes = vi.num_frames;//to test crash
	vi = reversed->GetVideoInfo();		
	//vi.num_frames= originalframes;
}
PVideoFrame __stdcall ReverseHalfBlend::GetFrame(int n, IScriptEnvironment *env)
{
	return reversed->GetFrame(n, env);
}

ReverseWovenBlend::ReverseWovenBlend(PClip toreverse, Blend *blend, IScriptEnvironment *env)
	: GenericVideoFilter(toreverse),
	evenpart(new ReverseHalfBlend(toreverse, blend, 0, env)),
	oddpart(new ReverseHalfBlend(toreverse, blend, 1, env))
{
	//int originalframes = vi.num_frames;
	vi = evenpart->GetVideoInfo();//fix... FIX
	vi.num_frames += oddpart->GetVideoInfo().num_frames;

}
PVideoFrame __stdcall ReverseWovenBlend::GetFrame(int n, IScriptEnvironment *env)
{	/*ofstream output("calls.txt",ios_base::app);
output<<"first frame\n";
	for(map<string, int>::const_iterator i = calls.begin(); i != calls.end(); ++i)
		output<<i-> second << "\t" <<i-> first<< "\n";*/

	if(n % 2 == 0)
		return evenpart->GetFrame(n/2, env);
	else
		return oddpart->GetFrame(n/2, env);
}